Index: libcfs/include/libcfs/linux/linux-prim.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/linux/linux-prim.h,v
retrieving revision 1.10
diff -u -p -r1.10 linux-prim.h
--- libcfs/include/libcfs/linux/linux-prim.h	1 Dec 2009 02:23:48 -0000	1.10
+++ libcfs/include/libcfs/linux/linux-prim.h	1 Jan 2010 20:03:33 -0000
@@ -69,14 +69,58 @@
 
 #include <libcfs/linux/linux-time.h>
 
+/** \addtogroup libcfs
+ * @{ */
+
+/** \addtogroup libcfs_misc
+ * @{
+ * \defgroup libcfs_linux_misc Misc. (linux-specific)
+ * @{ */
 #define CFS_EXPORT_SYMBOL(s)            EXPORT_SYMBOL(s)
+/** @} */
+/** @} */
 
-/*
- * Pseudo device register
- */
+/** \addtogroup libcfs_ioctl
+ * @{
+ * \defgroup libcfs_linux_ioctl Pseudo devices and ioctls (linux-specific, kernel-space)
+ * @{ */
 typedef struct miscdevice		cfs_psdev_t;
 #define cfs_psdev_register(dev)		misc_register(dev)
 #define cfs_psdev_deregister(dev)	misc_deregister(dev)
+/** @} */
+/** @} */
+
+
+/** \addtogroup libcfs_procfs
+ * @{
+ * \defgroup libcfs_linux_procfs Procfs and sysctl (linux-specific, kernel-space)
+ * Linux implementation of procfs and sysctl API
+ *
+ * Generic API for procfs and sysctl is described in \ref libcfs_procfs.
+ * Libcfs implements this API for linux in-kernel users in
+ * straightforward way using appropriate linux-native types and
+ * functions.
+ *
+ * As for sysctl, it also adds another useful macro: \a DECLARE_PROC_HANDLER.
+ * So, linux-specific consumer code has two ways for defining sysctl callback:
+ *
+ * 1. Using \a LL_PROC_PROTO macro like this:
+ * "int LL_PROC_PROTO(name_of_callback) {"
+ *
+ * 2. Using \a DECLARE_PROC_HANDLER. In this case the consumer should
+ * firstly implement a callback with name prepent by "__" like this:
+ * "static int __name_of_callback(void *data, int write, loff_t pos,
+ * void *buffer, int nob) { ... implementation ...}". Then, this macro
+ * should be used with name of callback (without "__") as its only
+ * argument: "DECLARE_PROC_HANDLER(name_of_callback);"
+ *
+ * The macro \a DECLARE_PROC_HANDLER allows consumer to avoid
+ * duplication of code related to updating \a lenp and \a ppos that
+ * linux kernel passes as arguments to sysctl callback. See
+ * implementation of \a proc_call_handler in linux-proc.c for details.
+ *
+ * @{
+ */
 
 /*
  * Sysctl register
@@ -103,6 +147,24 @@ LL_PROC_PROTO(name)                     
 }
 
 /*
+ * Proc file system APIs
+ */
+typedef read_proc_t                     cfs_read_proc_t;
+typedef write_proc_t                    cfs_write_proc_t;
+typedef struct proc_dir_entry           cfs_proc_dir_entry_t;
+#define cfs_create_proc_entry(n, m, p)  create_proc_entry(n, m, p)
+#define cfs_free_proc_entry(e)          free_proc_entry(e)
+#define cfs_remove_proc_entry(n, e)     remove_proc_entry(n, e)
+
+/** @} libcfs_linux_procfs */
+/** @} libcfs_procfs */
+
+/** \addtogroup libcfs_misc
+ * @{
+ * \addtogroup libcfs_linux_misc
+ * @{ */
+
+/*
  * Symbol register
  */
 #if (LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0))
@@ -121,18 +183,21 @@ LL_PROC_PROTO(name)                     
 #define cfs_module_put()                module_put(THIS_MODULE)
 #endif
 
-/*
- * Proc file system APIs
- */
-typedef read_proc_t                     cfs_read_proc_t;
-typedef write_proc_t                    cfs_write_proc_t;
-typedef struct proc_dir_entry           cfs_proc_dir_entry_t;
-#define cfs_create_proc_entry(n, m, p)  create_proc_entry(n, m, p)
-#define cfs_free_proc_entry(e)          free_proc_entry(e)
-#define cfs_remove_proc_entry(n, e)     remove_proc_entry(n, e)
+/** @} libcfs_linux_misc */
+/** @} libcfs_misc */
 
-/*
- * Wait Queue
+/** \addtogroup libcfs_synchronization
+ * @{
+ * \addtogroup libcfs_linux_synchronization
+ * @{
+ * \defgroup libcfs_linux_waitqueue Wait queues
+ * wait-queue (linux-specific)
+ *
+ * For linux case, Libcfs implements wait-queue primitives in trivial
+ * way by direct calls of correspondent linux-native primitives.
+ *
+ * \see \ref libcfs_waitqueue for general description.
+ * @{
  */
 #define CFS_TASK_INTERRUPTIBLE          TASK_INTERRUPTIBLE
 #define CFS_TASK_UNINT                  TASK_UNINTERRUPTIBLE
@@ -143,6 +208,14 @@ typedef struct proc_dir_entry           
 typedef wait_queue_t			cfs_waitlink_t;
 typedef wait_queue_head_t		cfs_waitq_t;
 typedef long                            cfs_task_state_t;
+/** @} libcfs_linux_waitqueue */
+/** @} libcfs_linux_synchronization */
+/** @} libcfs_synchronization */
+
+/** \addtogroup libcfs_misc
+ * @{
+ * \addtogroup libcfs_linux_misc
+ * @{ */
 
 #define cfs_kthread_run(fn, data, fmt, arg...) kthread_run(fn, data, fmt, ##arg)
 
@@ -184,17 +257,47 @@ module_init(init);                      
 module_exit(fini)
 
 /*
- * Signal
+ * interrupt
+ */
+
+#define cfs_in_interrupt() in_interrupt()
+
+/** @} libcfs_linux_misc */
+/** @} libcfs_misc */
+
+/** \addtogroup libcfs_signal
+ * @{
+ * \defgroup libcfs_linux_signal Signal (linux-specific)
+ * @{
  */
 typedef sigset_t                        cfs_sigset_t;
+/** @} */
+/** @} */
 
-/*
- * Timer
+/** \addtogroup libcfs_timer
+ * @{
+ * \defgroup libcfs_linux_timer Timer (linux-specific)
+ * @{
  */
 typedef struct timer_list cfs_timer_t;
+/** @} */
+/** @} */
 
+/** \addtogroup libcfs_schedule
+ * @{
+ * \defgroup libcfs_linux_schedule Schedule (linux-specific)
+ * @{ */
+/** linux-specific infinite timeout */
 #define CFS_MAX_SCHEDULE_TIMEOUT MAX_SCHEDULE_TIMEOUT
+/** @} */
+/** @} */
 
+/** \addtogroup libcfs_synchronization
+ * @{
+ * \addtogroup libcfs_linux_synchronization
+ * @{
+ * \addtogroup libcfs_linux_waitqueue
+ * @{ */
 #ifndef wait_event_timeout /* Only for RHEL3 2.4.21 kernel */
 #define __wait_event_timeout(wq, condition, timeout, ret)        \
 do {                                                             \
@@ -220,10 +323,7 @@ do {                                    
 		remove_wait_queue(&wq, &__wait);                 \
 	}                                                        \
 } while (0)
-/*
-   retval == 0; condition met; we're good.
-   retval > 0; timed out.
-*/
+
 #define cfs_waitq_wait_event_timeout(wq, condition, timeout, ret)    \
 do {                                                                 \
 	ret = 0;                                                     \
@@ -231,6 +331,29 @@ do {                                    
 		__wait_event_timeout(wq, condition, timeout, ret);   \
 } while (0)
 #else
+/**
+ * Conditional wait for an event with specified timeout. If
+ * \a condition is already satisfied, the call returns
+ * immediately. Otherwise, caller will go to sleep till other thread
+ * issues a signal (e.g. cfs_waitq_signal) or timeout expires.
+ *
+ * See \ref libcfs_waitqueue for background info about wait-queues.
+ *
+ * NOTE: Locking strategy is quite different from the usage of other
+ * wait-queue primitives like cfs_waitq_timedwait. To ensure MT-safety
+ * here, the caller only needs lock protection for check/update of
+ * resource what it waits for. Linux resolves 'lost wakeup' problem
+ * internally, at os scheduler layer.
+ * 
+ * \param wq Wait-queue to be signalled to wake up caller
+ * \param condition Condition to check before sleep. Should return
+ * TRUE if resource is available and the caller needn't sleep.
+ * \param timeout Maximum duration (in machine ticks) of
+ * sleep if no signal happens.
+ * \param ret Local variable of 'int' type to store return code:
+ * - ret == 0; condition met; we're good.
+ * - ret > 0; timed out.
+ */
 #define cfs_waitq_wait_event_timeout(wq, condition, timeout, ret)    \
         ret = wait_event_timeout(wq, condition, timeout)
 #endif
@@ -279,12 +402,22 @@ do {                                    
 						timeout, ret);     \
 } while (0)
 #else
+/**
+ * Conditional interruptible wait for an event with specified timeout.
+ *
+ * Exactly the same as cfs_waitq_wait_event_timeout but ensures sleep
+ * in interruptible way. Upon return, \a ret can also be negative
+ * meaning that sleep was interrupted.
+ */
 #define cfs_waitq_wait_event_interruptible_timeout(wq, c, timeout, ret) \
         ret = wait_event_interruptible_timeout(wq, c, timeout)
 #endif
+/** @} libcfs_linux_waitqueue */
 
-/*
- * atomic
+/**
+ * \defgroup libcfs_linux_atomic Atomics
+ * atomic (use Linux kernel's primitives)
+ * @{
  */
 
 typedef atomic_t cfs_atomic_t;
@@ -297,16 +430,20 @@ typedef atomic_t cfs_atomic_t;
 #define cfs_atomic_add(value, atom)   atomic_add(value, atom)
 #define cfs_atomic_sub(value, atom)   atomic_sub(value, atom)
 
-/*
- * membar
- */
-
-#define cfs_mb() mb()
+/** @} libcfs_linux_atomic */
 
-/*
- * interrupt
+/**
+ * \defgroup libcfs_linux_membar Membar
+ * Memory barrier. Ensures that all CPU-caches are synchronized
+ * avoiding situation when one thread executed 'a=1;' then 'b=2;' but
+ * another thread might observe these changes in reverse order.
+ * @{
  */
+#define cfs_mb() mb()
 
-#define cfs_in_interrupt() in_interrupt()
+/** @} libcfs_linux_membar */
+/** @} libcfs_linux_synchronization */
+/** @} libcfs_synchronization */
 
+/** @} libcfs */
 #endif
Index: libcfs/include/libcfs/linux/linux-tcpip.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/linux/linux-tcpip.h,v
retrieving revision 1.6
diff -u -p -r1.6 linux-tcpip.h
--- libcfs/include/libcfs/linux/linux-tcpip.h	26 Oct 2009 08:08:25 -0000	1.6
+++ libcfs/include/libcfs/linux/linux-tcpip.h	1 Jan 2010 20:03:33 -0000
@@ -51,6 +51,18 @@
 
 #include <net/sock.h>
 
+/** \addtogroup libcfs
+ * @{
+ * \addtogroup libcfs_net
+ * @{
+ * \addtogroup libcfs_kernel_net
+ * @{
+ * \defgroup libcfs_linux_net Network API (kernel-space, linux-specific)
+ *
+ * See \ref libcfs_net for generic description.
+ * @{ */
+
+/** This is how linux-kernel libcfs abstracts linux-native socket */
 typedef struct socket   cfs_socket_t;
 
 #if (LINUX_VERSION_CODE < KERNEL_VERSION(2,5,72))
@@ -71,7 +83,9 @@ typedef struct socket   cfs_socket_t;
 # define sk_route_caps  route_caps
 #endif
 
+/** obsoleted */
 #define SOCK_SNDBUF(so)         ((so)->sk->sk_sndbuf)
+/** returns TRUE if socket is still in 'ENOMEM' state */
 #define SOCK_TEST_NOSPACE(so)   test_bit(SOCK_NOSPACE, &(so)->flags)
 
 static inline int
@@ -80,6 +94,7 @@ libcfs_sock_error(struct socket *sock)
         return sock->sk->sk_err;
 }
 
+/** returns # not-ACK-ed bytes in send buffer */
 static inline int
 libcfs_sock_wmem_queued(struct socket *sock)
 {
@@ -93,4 +108,8 @@ libcfs_sock_wmem_queued(struct socket *s
 #define DEFAULT_NET	(NULL)
 #endif
 
+/** @} libcfs_linux_net */
+/** @} libcfs_kernel_net */
+/** @} libcfs_net */
+/** @} libcfs */
 #endif
Index: libcfs/include/libcfs/linux/linux-time.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/linux/linux-time.h,v
retrieving revision 1.5
diff -u -p -r1.5 linux-time.h
--- libcfs/include/libcfs/linux/linux-time.h	10 Feb 2009 18:33:32 -0000	1.5
+++ libcfs/include/libcfs/linux/linux-time.h	1 Jan 2010 20:03:33 -0000
@@ -51,9 +51,16 @@
 #error This include is only for kernel use.
 #endif
 
-/* Portable time API */
+/** \addtogroup libcfs
+ * @{ */
 
-/*
+/** \addtogroup libcfs_time
+ * @{ */
+
+/**
+ * \defgroup libcfs_linux_time Time (linux-specific)
+ * Portable time API for linux platform
+ *
  * Platform provides three opaque data-types:
  *
  *  cfs_time_t        represents point in time. This is internal kernel
@@ -87,7 +94,7 @@
  *
  *  CFS_TIME_FORMAT
  *  CFS_DURATION_FORMAT
- *
+ * @{
  */
 
 #define ONE_BILLION ((u_int64_t)1000000000)
@@ -110,7 +117,7 @@
 
 #if (LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0))
 
-/*
+/**
  * old kernels---CURRENT_TIME is struct timeval
  */
 typedef struct timeval cfs_fs_time_t;
@@ -126,7 +133,7 @@ static inline void cfs_fs_time_nsec(cfs_
         s->tv_nsec = t->tv_usec * 1000;
 }
 
-/*
+/**
  * internal helper function used by cfs_fs_time_before*()
  */
 static inline unsigned long long __cfs_fs_time_flat(cfs_fs_time_t *t)
@@ -158,7 +165,7 @@ static inline void cfs_fs_time_nsec(cfs_
         *s = *t;
 }
 
-/*
+/**
  * internal helper function used by cfs_fs_time_before*()
  */
 static inline unsigned long long __cfs_fs_time_flat(cfs_fs_time_t *t)
@@ -175,7 +182,9 @@ static inline unsigned long long __cfs_f
  * Generic kernel stuff
  */
 
-typedef unsigned long cfs_time_t;      /* jiffies */
+/** jiffies */
+typedef unsigned long cfs_time_t;
+/** jiffies at one point in time minus jiffies at another */
 typedef long cfs_duration_t;
 
 
@@ -298,7 +307,7 @@ static inline int cfs_time_beforeq_64(__
 #define cfs_time_beforeq_64 cfs_time_beforeq
 #endif
 
-/*
+/**
  * One jiffy
  */
 #define CFS_TICK                (1)
@@ -308,6 +317,10 @@ static inline int cfs_time_beforeq_64(__
 
 #define cfs_do_gettimeofday(tv) do_gettimeofday(tv)
 
+/* @} libcfs_linux_time */
+/* @} libcfs_time */
+/* @} libcfs */
+
 #endif /* __LIBCFS_LINUX_LINUX_TIME_H__ */
 /*
  * Local variables:
Index: libcfs/include/libcfs/linux/portals_compat25.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/linux/portals_compat25.h,v
retrieving revision 1.7
diff -u -p -r1.7 portals_compat25.h
--- libcfs/include/libcfs/linux/portals_compat25.h	1 Dec 2009 02:23:48 -0000	1.7
+++ libcfs/include/libcfs/linux/portals_compat25.h	1 Jan 2010 20:03:33 -0000
@@ -37,6 +37,9 @@
 #ifndef __LIBCFS_LINUX_PORTALS_COMPAT_H__
 #define __LIBCFS_LINUX_PORTALS_COMPAT_H__
 
+/** \addtogroup libcfs
+ * @{ */
+
 // XXX BUG 1511 -- remove this stanza and all callers when bug 1511 is resolved
 #if defined(SPINLOCK_DEBUG) && SPINLOCK_DEBUG
 # if (LINUX_VERSION_CODE >= KERNEL_VERSION(2,5,0)) || defined(CONFIG_RH_2_4_20)
@@ -96,11 +99,36 @@
 
 #endif
 
-# define cfs_wait_event_interruptible(wq, condition, ret)               \
+/** \addtogroup libcfs_synchronization
+ * @{
+ * \addtogroup libcfs_linux_synchronization
+ * @{
+ * \addtogroup libcfs_linux_waitqueue
+ * @{ */
+
+/**
+ * The same as cfs_waitq_wait_event_interruptible_timeout, but
+ * without timeout: the caller will sleep till signal.
+ */
+# define cfs_wait_event_interruptible(wq, condition, ret)       \
          ret = wait_event_interruptible(wq, condition)
+/**
+ * The same as cfs_wait_event_interruptible, but with exclusive semantic:
+ * only one waiter in given wait-queue will be woken up by
+ * cfs_waitq_signal.
+ */
 # define cfs_wait_event_interruptible_exclusive(wq, condition, ret)     \
          ret = wait_event_interruptible(wq, condition)
 
+/** @} libcfs_linux_waitqueue */
+/** @} libcfs_linux_synchronization */
+/** @} libcfs_synchronization */
+
+/** \addtogroup libcfs_misc
+ * @{
+ * \addtogroup libcfs_linux_misc
+ * @{ */
+
 #if defined(__arch_um__) && (LINUX_VERSION_CODE < KERNEL_VERSION(2,4,20))
 #define UML_PID(tsk) ((tsk)->thread.extern_pid)
 #elif defined(__arch_um__) && (LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0))
@@ -144,6 +172,14 @@ typedef unsigned long cpumask_t;
 #define __fls fls
 #endif
 
+/** @} libcfs_linux_misc */
+/** @} libcfs_misc */
+
+/** \addtogroup libcfs_procfs
+ * @{
+ * \addtogroup libcfs_linux_procfs
+ * @{ */
+
 #define ll_proc_dointvec(table, write, filp, buffer, lenp, ppos)        \
         proc_dointvec(table, write, filp, buffer, lenp, ppos);
 
@@ -162,4 +198,8 @@ int proc_call_handler(void *data, int wr
                       int (*handler)(void *data, int write,
                                      loff_t pos, void *buffer, int len));
 
+/** @} libcfs_linux_procfs */
+/** @} libcfs_procfs */
+
+/** @} libcfs */
 #endif /* _PORTALS_COMPAT_H */
Index: libcfs/include/libcfs/posix/libcfs.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/posix/libcfs.h,v
retrieving revision 1.13
diff -u -p -r1.13 libcfs.h
--- libcfs/include/libcfs/posix/libcfs.h	9 Oct 2009 13:46:20 -0000	1.13
+++ libcfs/include/libcfs/posix/libcfs.h	1 Jan 2010 20:03:33 -0000
@@ -106,13 +106,35 @@
 #include <libcfs/user-bitops.h>
 #include <libcfs/posix/posix-kernelcomm.h>
 
+/** \addtogroup libcfs
+ * @{ */
+
+/** \addtogroup libcfs_time
+ * @{
+ * \addtogroup libcfs_user_time
+ * @{ */
 # define do_gettimeofday(tv) gettimeofday(tv, NULL);
 typedef unsigned long long cycles_t;
+/** @} */
+/** @} */
+
+/** \addtogroup libcfs_misc
+ * @{
+ * \addtogroup libcfs_userspace_misc
+ * @{ */
 
 #define IS_ERR(a) ((unsigned long)(a) > (unsigned long)-1000L)
 #define PTR_ERR(a) ((long)(a))
 #define ERR_PTR(a) ((void*)((long)(a)))
 
+/* XXX Maxim: We shouldn't duplicate defining LUSTRE_LNET_PID in all
+ * platform-specific libcfs.h headers. Move it to common libcfs.h. */
+/** initial pid  */
+#define LUSTRE_LNET_PID          12345
+
+/** @} */
+/** @} */
+
 /* this goes in posix-fs.h */
 #include <sys/mount.h>
 
@@ -120,14 +142,33 @@ typedef unsigned long long cycles_t;
 #include <mntent.h>
 #endif
 
+/**
+ * \addtogroup libcfs_fs
+ * @{
+ * \defgroup libcfs_user_fs File operations for user-space users
+ * A few file-related bits for user-space
+ *
+ * Libcfs provides pretty limited file-related functionality for
+ * user-space:
+ * - types cfs_file_t, cfs_dentry_t and cfs_dirent_t
+ * - CFS_IFTODT and CFS_DTTOIF - conversion macros for directory type
+ * - read_actor_t - callback type for "sendfile" file operation
+ * @{
+ */
 typedef struct file cfs_file_t;
 typedef struct dentry cfs_dentry_t;
 #ifdef __linux__
 typedef struct dirent64 cfs_dirent_t;
 #endif
+/* @} libcfs_user_fs */
+/* @} libcfs_fs */
 
+/** \addtogroup libcfs_types
+ * @{
+ * \addtogroup libcfs_user_types
+ * @{ */
 #ifdef __linux__
-/* Userpace byte flipping */
+/* User-space byte flipping */
 # include <endian.h>
 # include <byteswap.h>
 # define __swab16(x) bswap_16(x)
@@ -194,7 +235,20 @@ typedef struct dirent64 cfs_dirent_t;
 #define __swab32s(x)                            do { *(x) = __swab32(*(x)); } while (0)
 #define __swab64s(x)                            do { *(x) = __swab64(*(x)); } while (0)
 #endif
+/** @} libcfs_user_types */
+/** @} libcfs_types */
 
+/** \addtogroup libcfs_debug
+ * @{
+ * \defgroup libcfs_user_debug Debugging (user-space)
+ * User-space implementation of Libcfs debug primitives.
+ *
+ * On some platforms (e.g. i386) the stack is very limited resource
+ * for kernel threads. This is not the case for user-space and Libcfs
+ * provides only stubs for controlling depth of stack in user-space.
+ *
+ * @{
+ */
 
 # ifndef THREAD_SIZE /* x86_64 linux has THREAD_SIZE in userspace */
 #  define THREAD_SIZE 8192
@@ -205,22 +259,36 @@ typedef struct dirent64 cfs_dirent_t;
 #define CHECK_STACK() do { } while(0)
 #define CDEBUG_STACK() (0L)
 
-/* initial pid  */
-#define LUSTRE_LNET_PID          12345
-
 #define ENTRY_NESTING_SUPPORT (1)
 #define ENTRY_NESTING   do {;} while (0)
 #define EXIT_NESTING   do {;} while (0)
 #define __current_nesting_level() (0)
+/** @} libcfs_user_debug */
+/** @} libcfs_debug */
 
-/**
- * Platform specific declarations for cfs_curproc API (libcfs/curproc.h)
- *
- * Implementation is in linux-curproc.c
+/** \addtogroup libcfs_curproc
+ * @{
+ * \defgroup libcfs_userspace_curproc Curproc (user-space)
+ * User-space implementation of curproc API (libcfs/curproc.h)
+ * @{
  */
+
+/** Maximum length of process name */
 #define CFS_CURPROC_COMM_MAX (sizeof ((struct task_struct *)0)->comm)
 
+/** obsoleted */
 typedef __u32 cfs_kernel_cap_t;
+/* XXX Maxim: It's useless to define cfs_kernel_cap_t in posix part of
+ * libcfs. The only user of cfs_kernel_cap_t is linux-specific lvfs
+ * that has nothing to do with posix */
+
+/** @} libcfs_userspace_curproc */
+/** @} libcfs_curproc */
+
+/** \addtogroup libcfs_misc
+ * @{
+ * \addtogroup libcfs_userspace_misc
+ * @{ */
 
 /**
  * Module support (probably shouldn't be used in generic code?)
@@ -410,6 +478,14 @@ static inline void radix_tree_preload_en
 {
 }
 
+/** @} libcfs_userspace_misc */
+/** @} libcfs_misc */
+
+/** \addtogroup libcfs_fs
+ * @{
+ * \addtogroup libcfs_user_fs
+ * @{ */
+
 typedef ssize_t (*read_actor_t)();
 
 #define CFS_IFSHIFT 12
@@ -417,4 +493,8 @@ typedef ssize_t (*read_actor_t)();
 #define CFS_IFTODT(type)           (((type) & S_IFMT) >> CFS_IFSHIFT)
 #define CFS_DTTOIF(dirtype)        ((dirtype) << CFS_IFSHIFT)
 
+/** @} libcfs_user_fs */
+/** @} libcfs_fs */
+/** @} libcfs */
+
 #endif
Index: libcfs/include/libcfs/posix/posix-kernelcomm.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/posix/posix-kernelcomm.h,v
retrieving revision 1.1
diff -u -p -r1.1 posix-kernelcomm.h
--- libcfs/include/libcfs/posix/posix-kernelcomm.h	28 Jul 2009 19:42:54 -0000	1.1
+++ libcfs/include/libcfs/posix/posix-kernelcomm.h	1 Jan 2010 20:03:33 -0000
@@ -47,6 +47,14 @@
 #error Do not #include this file directly. #include <libcfs/libcfs.h> instead
 #endif
 
+/** \addtogroup libcfs
+ * @{
+ * \addtogroup libcfs_lnl
+ * @{
+ * \defgroup libcfs_userspace_lnl Kernel <-> user-space communication (user-space)
+ * User-space side of kernel <-> user-space communication subsystem.
+ * @{ */
+
 typedef int lustre_netlink;
 int libcfs_ulnl_start(lustre_netlink *l, int groups);
 int libcfs_ulnl_stop(lustre_netlink *l);
@@ -55,5 +63,8 @@ int libcfs_ulnl_msg_get(lustre_netlink *
                         struct lnl_hdr **lnlhh);
 int libcfs_ulnl_msg_free(struct lnl_hdr **lnlhh);
 
+/** @} libcfs_userspace_lnl */
+/** @} libcfs_lnl */
+/** @} libcfs */
 #endif
 
Index: libcfs/include/libcfs/posix/posix-types.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/posix/posix-types.h,v
retrieving revision 1.6
diff -u -p -r1.6 posix-types.h
--- libcfs/include/libcfs/posix/posix-types.h	5 Aug 2009 11:37:51 -0000	1.6
+++ libcfs/include/libcfs/posix/posix-types.h	1 Jan 2010 20:03:33 -0000
@@ -43,6 +43,24 @@
 #define _LUSTRE_POSIX_TYPES_H
 
 #include <asm/types.h>
+
+/**
+ * \addtogroup libcfs
+ * @{
+ *
+ * \addtogroup libcfs_types
+ * @{
+ *
+ *\defgroup libcfs_user_types Generic types (user-space)
+ *
+ * Definitions of some generic types and swab primitives for user-space.
+ *
+ * For user-space, Libcfs adds types __s8, __u8, __s16, __u16, __s32,
+ * __u32, __s64, __u64, ulong_ptr_t, long_ptr_t and a bunch of swab
+ * primitives to be found in posix/libcfs.h
+ * @{
+ */
+
 #ifndef HAVE_UMODE_T
 typedef unsigned short umode_t;
 #endif
@@ -72,4 +90,8 @@ typedef unsigned long long __u64;
 typedef unsigned long ulong_ptr_t;
 typedef long long_ptr_t;
 
+/** @} libcfs_user_types */
+/** @} libcfs_types */
+/** @} libcfs */
+
 #endif
Index: libcfs/include/libcfs/posix/posix-wordsize.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/posix/posix-wordsize.h,v
retrieving revision 1.9
diff -u -p -r1.9 posix-wordsize.h
--- libcfs/include/libcfs/posix/posix-wordsize.h	26 Aug 2009 09:41:26 -0000	1.9
+++ libcfs/include/libcfs/posix/posix-wordsize.h	1 Jan 2010 20:03:33 -0000
@@ -55,6 +55,14 @@
 # include "ioctl.h"
 #endif
 
+/** \addtogroup libcfs
+ * @{ */
+
+/** \addtogroup libcfs_misc
+ * @{
+ * \defgroup libcfs_userspace_misc Misc. (user-space)
+ * @{ */
+
 # define CFS_MODULE_PARM(name, t, type, perm, desc)
 #define PORTAL_SYMBOL_GET(x) inter_module_get(#x)
 #define PORTAL_SYMBOL_PUT(x) inter_module_put(#x)
@@ -72,10 +80,17 @@
 #  define BITS_PER_LONG __WORDSIZE
 #endif
 
+/** @} libcfs_userspace_misc */
+/** @} libcfs_misc */
 
-/******************************************************************************/
-/* Light-weight trace
- * Support for temporary event tracing with minimal Heisenberg effect. */
+/**
+ * \addtogroup libcfs_lwt
+ * @{
+ * \defgroup libcfs_user_lwt Light-weight tracing (user-space)
+ *
+ * LWT is not implemented for user-space yet.
+ * @{
+ */
 #define LWT_SUPPORT  0
 
 #define LWT_MEMORY   (16<<20)
@@ -96,11 +111,23 @@ typedef struct {
 #if LWT_SUPPORT
 #define LWT_EVENT(p1,p2,p3,p4)     /* no userland implementation yet */
 #endif /* LWT_SUPPORT */
+/** @} libcfs_lwt */
+/** @} libcfs_user_lwt */
 
 /* ------------------------------------------------------------------ */
 
+/** \addtogroup libcfs_ioctl
+ * @{
+ * \defgroup libcfs_userspace_ioctl Pseudo devices and ioctls (user-space)
+ * @{ */
 #define IOCTL_LIBCFS_TYPE long
+/** @} */
+/** @} */
 
+/** \addtogroup libcfs_misc
+ * @{
+ * \addtogroup libcfs_userspace_misc
+ * @{ */
 
 #if BITS_PER_LONG > 32
 # define LI_POISON ((int)0x5a5a5a5a5a5a5a5a)
@@ -159,4 +186,9 @@ typedef struct {
  */
 # define LPPID "%d"
 
+/** @} libcfs_userspace_misc */
+/** @} libcfs_misc */
+
+/** @} libcfs */
+
 #endif
Index: libcfs/libcfs/debug.c
===================================================================
RCS file: /cvsroot/cfs/libcfs/libcfs/debug.c,v
retrieving revision 1.19
diff -u -p -r1.19 debug.c
--- libcfs/libcfs/debug.c	6 Nov 2009 13:54:48 -0000	1.19
+++ libcfs/libcfs/debug.c	1 Jan 2010 20:03:33 -0000
@@ -110,6 +110,7 @@ CFS_MODULE_PARM(libcfs_panic_on_lbug, "i
                 "Lustre kernel panic on LBUG");
 EXPORT_SYMBOL(libcfs_panic_on_lbug);
 
+/** # bytes "in use" (allocated but not freed yet) */
 atomic_t libcfs_kmemory = ATOMIC_INIT(0);
 EXPORT_SYMBOL(libcfs_kmemory);
 
